﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Infragistics.Documents.RichText;
//using Infragistics.Documents.RichText.Html;
using Infragistics.Documents.RichText.Rtf;
using Infragistics.Documents.RichText.Serialization;
using Infragistics.Controls.Editors;
using Infragistics.Windows;
using System.Windows.Controls.Primitives;

namespace RTE_Sample
{
    /// <summary>
    /// Interaction logic for RTEControl.xaml
    /// </summary>
    public partial class RTEControl : UserControl
    {
       string errors = string.Empty;
       private ScrollBar _scrollBar;
       private bool _firstMessage;
       private double _lastScrollPosition;
       private double _lastMaxScroll;

        public RTEControl()
        {
            InitializeComponent();
        }

        private void RTE_Loaded(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() =>
            {
                _scrollBar = Utilities.GetDescendantFromType((sender as XamRichTextEditor), typeof(ScrollBar), true) as ScrollBar;
            }));
           LoadChatHistory(false);
           // Have to wait until xamRichTextBox Load all components and chat History, otherwise scrollbar and ActivDocumentView wont be loaded
           Thread scroll = new Thread(() =>
           {
              Thread.Sleep(1500);
              RTE_Contact.Dispatcher.Invoke(DispatcherPriority.Normal,
                 new Action(() =>
                 {
                    ScrollDown();
                 }));
           });
           scroll.IsBackground = true;
           scroll.Start();
        }

        private List<string> GetMoreHistory(bool simple = false)
       {
          List<string> history = new List<string>();
          // 2 loops consume time equal to retriving data from DataBase
          for (int i = 0; i < 10; i++)
          {
             if (simple)
             {
                if ((i % 3) == 0)
                {
                   history.Add(String.Format("Message bla bla bla bla bla bla bla vbla bla bla bla bla bla bla bla bla bla bla bla bla " +
                                             "bla bla bla bla bla bla bla bla bla bla bla bla bla bla bla bla bla bla bla bla " +
                                             "bla bla bla bla bla bla bla bla "));
                }
                else
                   history.Add(String.Format("Message {0}", i));
             }
             else
             {
                Random randLenght = new Random();
                string msg = String.Empty;
                int _randLenght = randLenght.Next(1, 30);
                string bla = "bla ";
                for (int j = 0; j < _randLenght; j++)
                {
                   msg += bla;
                }
                history.Add(msg);
             }

          }
          return history;
       }
        private void LoadChatHistory(bool isSimple = false)
        {
           var history = GetMoreHistory(isSimple);
           foreach (var h in history)
           {
              InputTextInFront("User 1", h, DateTime.Now);
           }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            
            var text = RTE_Me.Document.GetTextInSpan(DocumentSpan.All);
            InputText("User 1", text, DateTime.Now);

            RTE_Me.Document.RootNode.Body.ChildNodes.Clear();
        }

        private void RTE_Contact_MouseWheel(object sender, MouseWheelEventArgs e)
        {
           //Temporary fix
           //if (e.Delta == 120 && _scrollBar.Value > _lastScrollPosition)
           //{
           //   _scrollBar.Value = _lastScrollPosition;
           //}

           if (_scrollBar.Value == 0)
           {
              var view = RTE_Contact.ActiveDocumentView;

              if (view != null && view.VerticalViewOffset == 0)
              { 
                 //Load More history in a front
                 //parameters:
                 // false- simualting loading from DataBase ( with longer oparation time) - IMPORTANT!!!
                 // true - simulate simple generated chat history w/o reading from other sources
                 LoadChatHistory(false);

                 var document = RTE_Contact.Document;
                 var paragraphs = document.GetParagraphs(DocumentSpan.All);
                 if (paragraphs != null && paragraphs.Count() > 0)
                 {
                    double d = paragraphs.ElementAt(58).GetDocumentSpan().Offset;
                    var dd = paragraphs.Last().GetDocumentSpan().Offset;
                    //RichTextBox.ActiveDocumentView.VerticalViewOffset = d;
                    _scrollBar.Value = _scrollBar.Maximum - _lastMaxScroll;
                 }
                 
              }
           }
           _lastScrollPosition = _scrollBar.Value;
           _lastMaxScroll = _scrollBar.Maximum;
        }
        #region InputText
        public void InputTextInFront(string username, string text, DateTime time)
        {
           // Create a FlowDocument
           RichTextDocument mcFlowDoc;
           mcFlowDoc = RTE_Contact.Document;
           if (!_firstMessage)
           {
              RTE_Contact.Document.RootNode.Body.ChildNodes.Clear();
              _firstMessage = true;
           }

           ParagraphNode paraNameNode = new ParagraphNode();
           paraNameNode.ChildNodes.Add(CreateRunNodeWithContent(nameCharacterSettings, username));
           paraNameNode.Settings = paraNameNodeSettings;
           ParagraphNode paraTimeNode = new ParagraphNode();
           paraTimeNode.ChildNodes.Add(CreateRunNodeWithContent(timeCharacterSettings, time.ToString()));
           paraTimeNode.Settings = paraTimeNodeSettings;

           // Add the paragraph to blocks of paragraph
           mcFlowDoc.RootNode.Body.ChildNodes.Insert(0, CreateMessageParagraphNode(text));
           mcFlowDoc.RootNode.Body.ChildNodes.Insert(0, paraTimeNode);
           mcFlowDoc.RootNode.Body.ChildNodes.Insert(0, paraNameNode);

           // Set contents
           RTE_Contact.Document = mcFlowDoc;

        }
        public void InputText(string username, string text, DateTime time)
        {
           // Create a FlowDocument
           RichTextDocument mcFlowDoc;
           mcFlowDoc = RTE_Contact.Document;
           if (!_firstMessage)
           {
              RTE_Contact.Document.RootNode.Body.ChildNodes.Clear();
              _firstMessage = true;
           }

           ParagraphNode paraNameNode = new ParagraphNode();
           paraNameNode.ChildNodes.Add(CreateRunNodeWithContent(nameCharacterSettings, username));
           paraNameNode.Settings = paraNameNodeSettings;
           ParagraphNode paraTimeNode = new ParagraphNode();
           // ReSharper disable once SpecifyACultureInStringConversionExplicitly
           paraTimeNode.ChildNodes.Add(CreateRunNodeWithContent(timeCharacterSettings, time.ToString()));
           paraTimeNode.Settings = paraTimeNodeSettings;

           // Add the paragraph to blocks of paragraph
           //mcFlowDoc.RootNode.Body.ChildNodes.Add(paraNameNode);
           //mcFlowDoc.RootNode.Body.ChildNodes.Add(paraTimeNode);
           //mcFlowDoc.RootNode.Body.ChildNodes.Add(CreateMessageParagraphNode(text));
           mcFlowDoc.RootNode.Body.ChildNodes.Insert(mcFlowDoc.RootNode.Body.ChildNodes.Count, paraNameNode);
           mcFlowDoc.RootNode.Body.ChildNodes.Insert(mcFlowDoc.RootNode.Body.ChildNodes.Count, paraTimeNode);
           mcFlowDoc.RootNode.Body.ChildNodes.Insert(mcFlowDoc.RootNode.Body.ChildNodes.Count, CreateMessageParagraphNode(text));

           // Set contents
           RTE_Contact.Document = mcFlowDoc;
           ScrollDown();

        }
        #endregion

        #region Create Node
        private ParagraphNode CreateMessageParagraphNode(string text)
        {
           ParagraphNode messageParagraphNode = new ParagraphNode();

           messageParagraphNode.ChildNodes.Add(CreateRunNodeWithAvatar(null, null));
           messageParagraphNode.ChildNodes.Add(CreateRunNodeWithContent(messageCharacterSettings, text));

           messageParagraphNode.Settings = messageParagraphNodeSettings;
           return messageParagraphNode;
        }
        private RunNode CreateRunNodeWithContent(CharacterSettings cs, string content)
        {
           RunNode rn = new RunNode();
           if (cs != null) rn.Settings = cs;
           if (content != null) rn.SetText(content);
           return rn;
        }
        private RunNode CreateRunNodeWithAvatar(CharacterSettings cs, string user)
        {
           RichTextImage rtImage = RichTextImage.CreateFrom("../../awatar35x35.jpg", RichTextImageFormat.Jpeg);
           ImageNode imgNode = new ImageNode();
           imgNode.Image = rtImage;
           imgNode.Transform = new RichTextImageTransform();
           imgNode.Transform.StretchSize = new RichTextSize(new Size(35, 35));

           RichTextMargin? rtm = imgNode.RenderEffectsMargin;
           if (!rtm.HasValue)
           {
              rtm = new RichTextMargin();
              imgNode.RenderEffectsMargin = rtm;
           }

           RichTextMargin margin = rtm.Value;
           margin.Bottom = new Extent(-20, ExtentUnitType.LogicalPixels);
           margin.Left = new Extent(-45, ExtentUnitType.LogicalPixels);
           imgNode.RenderEffectsMargin = margin;


           var rn = new RunNode();
           if (cs != null) rn.Settings = cs;
           if (user == null) rn.ChildNodes.Add(imgNode);
           return rn;
        }
        #endregion

        #region Paragraph Settings
        ParagraphSettings paraNameNodeSettings = new ParagraphSettings
        {
           //Indentation = new ParagraphIndentationSettings()
           //{
           //   Start = new Indentation(new Extent(40, ExtentUnitType.LogicalPixels))
           //},
           ParagraphAlignment = ParagraphAlignment.Start,
           KeepWithNext = true,
           Spacing = new ParagraphSpacingSettings
           {
              AfterParagraph = new ParagraphVerticalSpacing(new Extent(0, ExtentUnitType.LogicalPixels)),
              LineSpacing = new LineSpacing(new Extent(0, ExtentUnitType.LogicalPixels), ExtentRule.Exact)
           }
        };
        ParagraphSettings paraTimeNodeSettings = new ParagraphSettings
        {
           //Indentation = new ParagraphIndentationSettings()
           //{
           //   Start = new Indentation(new Extent(40, ExtentUnitType.LogicalPixels))
           //},
           ParagraphAlignment = ParagraphAlignment.End,
           KeepWithNext = true,
           MirrorIndents = true,
           Spacing = new ParagraphSpacingSettings
           {
              BeforeParagraph = new ParagraphVerticalSpacing(new Extent(0, ExtentUnitType.LogicalPixels)),
              AfterParagraph = new ParagraphVerticalSpacing(new Extent(0, ExtentUnitType.LogicalPixels)),
              LineSpacing = new LineSpacing(new Extent(0, ExtentUnitType.LogicalPixels), ExtentRule.Exact)
           }
        };
        ParagraphSettings messageParagraphNodeSettings = new ParagraphSettings
        {
           Indentation = new ParagraphIndentationSettings
           {
              Start = new Indentation(new Extent(50, ExtentUnitType.LogicalPixels)),
              End = new Indentation(new Extent(50, ExtentUnitType.LogicalPixels))
           },
           Spacing = new ParagraphSpacingSettings
           {
              //BeforeParagraph = new ParagraphVerticalSpacing(new Extent(10, ExtentUnitType.LogicalPixels)),
              AfterParagraph = new ParagraphVerticalSpacing(new Extent(20, ExtentUnitType.LogicalPixels)),
              //LineSpacing = new LineSpacing(new Extent(0, ExtentUnitType.LogicalPixels), ExtentRule.Exact)
           },
           AdjustRightIndent = true,
           MirrorIndents = true,
           WordWrap = true,
           ParagraphAlignment = ParagraphAlignment.Start
        };
        #endregion

        #region Font Settings
        private static FontSettings mainFont = new FontSettings
        {
           Ascii = new RichTextFont("Verdana")
        };
        CharacterSettings nameCharacterSettings = new CharacterSettings
        {
           Bold = true,
           FontSize = new Extent(11, ExtentUnitType.Points),
           FontSettings = mainFont
        };


        CharacterSettings timeCharacterSettings = new CharacterSettings
        {
           FontSize = new Extent(8, ExtentUnitType.Points),
           FontSettings = mainFont
        };
        CharacterSettings messageCharacterSettings = new CharacterSettings
        {
           FontSize = new Extent(10, ExtentUnitType.Points),
           FontSettings = mainFont
        };
        #endregion

        internal void ScrollDown()
        {
           var paragraphs = RTE_Contact.Document.GetParagraphs(DocumentSpan.All);
           if (paragraphs != null && paragraphs.Count() > 0)
           {
              //var d = paragraphs.LastOrDefault().GetDocumentSpan();
              //RTE_Contact.ActiveDocumentView.VerticalViewOffset = d.Offset + d.Length;
              //double d = _scrollBar.Maximum;
              _scrollBar.Value = _scrollBar.Maximum;
              _lastScrollPosition = _scrollBar.Value;
           }
        }
    }
}
